AWSTemplateFormatVersion: "2010-09-09"
Description: Creates ALB for generic service/ instance
Parameters:
  EnvironmentAbbr:
    Type       : String
  StackName:
    Type       : String
  VPCID:
    Description: VPC Id
    Type       : AWS::EC2::VPC::Id
  Subnets:
    Type       : List<AWS::EC2::Subnet::Id>

  S3Bucket:
    Description: S3 bucket name where the alb can log to
    Type       : String

  ALBScheme:
    Type       : String
  SslPolicy:
    Type       : String

Conditions:
  IsInternal: !Equals [!Ref ALBScheme, "internal"]

Resources:
  ALBSecurityGroup:
    Type: AWS::EC2::SecurityGroup
    Properties:
      GroupDescription: Enable public access to the cluster 
      VpcId: !Ref VPCID
      SecurityGroupIngress:
      - IpProtocol: tcp
        FromPort: 80
        ToPort: 80
        CidrIp: 0.0.0.0/0
      - IpProtocol: tcp
        FromPort: 443 
        ToPort: 443 
        CidrIp: 0.0.0.0/0
      Tags:
        - Key: Name
          Value: !Sub "${StackName}sec-ALB"

#  SGALBSGInTCP:
#    Type: AWS::EC2::SecurityGroupIngress
#    Properties:
#      Description: "Allow ALB to connect EC2 instances"
#      GroupName: !Ref ALBSecurityGroup
#      IpProtocol: tcp
##      CidrIp: 0.0.0.0/0
#      FromPort: 80 
#      ToPort: 80 
#      #SourceSecurityGroupId: !GetAtt ALBSecurityGroup.GroupId 

  ALB:
    Type: AWS::ElasticLoadBalancingV2::LoadBalancer
    Properties:
      Scheme: !Ref ALBScheme
      Subnets: !Ref Subnets
      LoadBalancerAttributes:
        - Key: idle_timeout.timeout_seconds
          Value: '60'
        - Key: access_logs.s3.enabled
          Value: 'true'
        - Key: access_logs.s3.bucket
          Value: !Ref S3Bucket
        - Key: access_logs.s3.prefix
          Value: !Sub '${AWS::StackName}-ALB'
      SecurityGroups:
        - !Ref ALBSecurityGroup
        - Fn::If:
          - IsInternal
          - Fn::ImportValue: !Sub "${EnvironmentAbbr}-securitygroups-AdminVPNSGID"
          - Fn::ImportValue: !Sub "${EnvironmentAbbr}-securitygroups-AdminOfficeSGID"
        - Fn::If:
          - IsInternal
          - Fn::ImportValue: !Sub "${EnvironmentAbbr}-securitygroups-CustomerVPNSGID"
          - Fn::ImportValue: !Sub "${EnvironmentAbbr}-securitygroups-CustomerOfficeSGID"
      Tags:
        - Key: Name
          Value: !Sub ${AWS::StackName}

  # We need a default action for our listener, so we create a dummy target group for that
  DefaultTargetGroup80:
    Type: AWS::ElasticLoadBalancingV2::TargetGroup
    Properties:
      Name: !Sub "${AWS::StackName}80"
      VpcId: !Ref VPCID
      Port: 80
      Protocol: HTTP
      Tags:
        - Key: Name
          Value: !Sub "${AWS::StackName}80"

  DefaultTargetGroup443:
    Type: AWS::ElasticLoadBalancingV2::TargetGroup
    Properties:
      Name: !Sub "${AWS::StackName}443"
      VpcId: !Ref VPCID
      Port: 443 
      Protocol: HTTPS
      Tags:
        - Key: Name
          Value: !Sub "${AWS::StackName}443"

{% for port, properties in listeners.items() %}
  LoadBalancerListener{{ port }}:
    Type: AWS::ElasticLoadBalancingV2::Listener
    Properties:
      DefaultActions:
        - Type: forward
          TargetGroupArn: !Ref DefaultTargetGroup{{ port }}
      LoadBalancerArn: !Ref ALB
      Port: '{{ port }}'
{% if 'ssl' in properties %}
      Certificates:
        - CertificateArn: "{{ properties.certificate_arn }}"
      SslPolicy: !Ref SslPolicy
      Protocol: HTTPS
{% else %}
      Protocol: HTTP
{% endif %}

{% if 'ssl' in properties and 'extra_certificate_arns' in properties and (properties.extra_certificate_arns | length > 0) %}
  Listener{{ port }}Certificates:
    Type: "AWS::ElasticLoadBalancingV2::ListenerCertificate"
    DependsOn:
      - LoadBalancerListener{{ port }}
    Properties:
      Certificates:
{% for certificate in properties.extra_certificate_arns %}
        - CertificateArn: {{ certificate }}
{% endfor %}
      ListenerArn: !Ref LoadBalancerListener{{ port }}
{% endif %}
{% endfor %}

Outputs:
  ALB:
    Value: !Ref ALB
    Description: ALB
    Export:
      Name: !Sub "${AWS::StackName}-ALB"
  ALBFullName:
    Value: !GetAtt ALB.LoadBalancerFullName
    Description: ALB Full name
    Export:
      Name: !Sub "${AWS::StackName}-ALBFullName"
#  ALBSGID:
#    Description: Security group used by ECS ALB
#    Value: !Ref ALBSecurityGroup
#    Export:
#      Name: !Sub "${AWS::StackName}-ALBSGID"
  ALBDNS:
    Value: !GetAtt ALB.DNSName
    Export:
      Name: !Sub "${AWS::StackName}-ALBDNS"
  ALBZoneID:
    Value: !GetAtt ALB.CanonicalHostedZoneID
    Export:
      Name: !Sub "${AWS::StackName}-ALBZoneID"
{% for port, properties in listeners.items() %}
  LoadBalancerListener{{ port }}:
    Value: !Ref LoadBalancerListener{{ port }}
    Export:
      Name: !Sub "${AWS::StackName}-LoadBalancerListener{{ port }}"
{% endfor %}
